# Contribution Guidelines

We welcome contributions from everyone to this repository, and we thank you for dedicating
your time to the improvement of this repository and for sharing your work with everyone in
our community.

## Issue Tracking

Please report issues to the issue tracker here. Use the provided template to ensure we have
a reproducible and actionable issue report.

## Pull Requests

Please use pull requests from branches within this repository or from branches on your own
forks.
* Consider submitting multiple pull requests frequently in order to keep the number of
  changes limited and self-contained.
* A number of mandatory tests will be run on each pull request. We cannot bypass these
  tests, not even for core developers.
* All pull requests, also those by core developers, are required to pass a review by at
  least one (other) core developer.

Please create a pull request (or an issue) as soon as you start working on a new feature or
bug fix. You can mark the pull request as a "draft pull request" in those cases. This helps
letting developers and other users know that someone is working on this feature and avoids
duplicate work.

## Coding Conventions

* All code in this repository should compile without warnings (including unused variables).
* All code in this repository must be formatted using the clang-format conventions.
